package de.lmu.mobilehci.fittsthumbindex;

import java.util.Arrays;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.view.MotionEvent;
import android.view.View;

public class FittsView extends View {

	private Context context = null;

	// Zielgre
	private final static int W = 60;

	// Werte im Array durch die Distanzwerte fr ID = 1.5, 2, 2.5, 3 und 3.5 ersetzen
	private final static int[] Ds = { 0, 0, 0, 0, 0 };

	// aktueller Distanzwert
	private int D = 0;
	
	// index of difficulty: ID = log2(D/W+1)
	private double ID = 0;

	// Display-Gre
	private int width, height;

	// linke obere Ecken von Ziel 1 und Ziel 2
	private int target1x, target1y, target2x, target2y;
	
	// nchstes auszuwhlendes Ziel
	private int nextTarget = 0;
	
	// letzte Berhrposition
	private int touchX, touchY;
	
	// Farben
	private final Paint paintBlack = new Paint();
	private final Paint paintWhite = new Paint();
	private final Paint paintRed = new Paint();
	private final Paint paintGreen = new Paint();

	// weitere Variablen definieren...

	
	
	public FittsView(Context c, int id) {
		super(c);
		context = c;

		ID = id / 10.0;
		D = Ds[(id - 15) / 5];
		
		paintBlack.setARGB(255, 0, 0, 0);
		paintWhite.setARGB(255, 255, 255, 255);
		paintWhite.setTextSize(24);
		paintRed.setARGB(255, 255, 0, 0);
		paintGreen.setARGB(255, 0, 255, 0);
	}
	
	protected void onSizeChanged(int w, int h, int oldw, int oldh) {
		width = w;
		height = h;
		
		target1x = width / 2 - W / 2;
		target2x = width / 2 - W / 2;
		
		target1y = height / 2 - W / 2 - D / 2;
		target2y = height / 2 - W / 2 + D / 2;
		
	}
	
	protected void onDraw(Canvas c) {
		
		// falls noch nicht alle 40 Eingaben, Ziele anzeigen
		// ...
		
		// falls alle Eingaben vorhanden, Ergebnis anzeigen (mean bzw. median time, ID-Wert)
		// ...
	}
	
	public boolean onTouchEvent(MotionEvent e) {

		if (e.getAction() == MotionEvent.ACTION_DOWN) {
			int x = (int)e.getX(); 
			int y = (int)e.getY();
			long time = e.getEventTime(); // Zeitstempel (in Millisekunden seit 1.1.1970) 

			touchX = x;
			touchY = y;

			// Ist Berhrpunkt im nchaten Ziel?
			// Zeitpunkt bzw. Zeitdauer merken
			
			// falls alle Eingaben gemacht: Durchschnittszeit pro Eingabe berechnen
			// arithmetisches Mittel oder (besser) Median
			
			// Median: Array sortieren und mittleres Element auswhlen
			// Arrays.sort(deltas);
			// ...
		}

		invalidate();
		return true;

	}
	
}
